var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
import path from "path";
import { createMatchPath } from "@modern-js/utils/tsconfig-paths";
import { getUserAlias } from "@modern-js/utils";
const { resolvePath } = require("babel-plugin-module-resolver");
const defaultPaths = { "@": ["./src"] };
const aliasPlugin = (alias) => {
  const { absoluteBaseUrl, isTsPath, isTsProject = false } = alias;
  const mergedPaths = isTsPath ? alias.paths || {} : __spreadValues(__spreadValues({}, defaultPaths), alias.paths || {});
  let tsPaths = {};
  if (isTsProject) {
    tsPaths = getUserAlias(mergedPaths);
  }
  tsPaths = Object.keys(tsPaths).reduce((o, key) => {
    if (typeof tsPaths[key] === "string") {
      return __spreadProps(__spreadValues({}, o), {
        [`${key}`]: [tsPaths[key]]
      });
    }
    return __spreadProps(__spreadValues({}, o), {
      [`${key}`]: tsPaths[key]
    });
  }, {});
  const resolvePathFn = (sourcePath, currentFile, opts) => {
    if (sourcePath === "." || sourcePath === "./") {
      return sourcePath;
    }
    const matchPath = createMatchPath(
      absoluteBaseUrl,
      tsPaths,
      ["index"]
    );
    const result = matchPath(sourcePath, void 0, void 0, [
      ".js",
      ".jsx",
      ".ts",
      ".tsx"
    ]);
    if (result) {
      const relativePath = path.relative(
        path.dirname(currentFile),
        path.dirname(result)
      );
      const fileName = path.basename(result);
      const filePath = path.normalize(
        `${relativePath.length === 0 ? "." : relativePath}/${fileName}`
      ).replace(/\\/, "/");
      return filePath.startsWith(".") ? filePath : `./${filePath}`;
    }
    return resolvePath(sourcePath, currentFile, opts);
  };
  const typescriptExts = [".ts", ".tsx", ".js", ".jsx", ".es", ".es6", ".mjs"];
  return [
    "babel-plugin-module-resolver",
    {
      root: absoluteBaseUrl,
      alias: mergedPaths,
      resolvePath: isTsPath ? resolvePathFn : void 0,
      extensions: isTsProject ? typescriptExts : void 0
    }
  ];
};
export {
  aliasPlugin
};
